diff -r 90d8167d4c80 code/nel/src/3d/driver/opengl/mac/cocoa_event_emitter.cpp
--- a/code/nel/src/3d/driver/opengl/mac/cocoa_event_emitter.cpp	Wed Sep 14 01:47:27 2011 +0300
+++ b/code/nel/src/3d/driver/opengl/mac/cocoa_event_emitter.cpp	Sun Sep 18 21:15:34 2011 -1000
@@ -149,14 +149,27 @@
 
 bool CCocoaEventEmitter::pasteTextFromClipboard(ucstring &text)
 {
-#warning "OpenGL Driver: Missing Mac Implementation for pasteTextFromClipboard"
+	NSPasteboard *pasteboard = [NSPasteboard generalPasteboard];
+	NSArray *classArray = [NSArray arrayWithObject:[NSString class]];
+	NSDictionary *options = [NSDictionary dictionary];
+	
+	BOOL ok = [pasteboard canReadObjectForClasses:classArray options:options];
+	if (ok) {
+		NSArray *objectsToPaste = [pasteboard readObjectsForClasses:classArray options:options];
+		NSString *nstext = [objectsToPaste objectAtIndex:0];
+		text.fromUtf8([nstext UTF8String]);
+		return true;
+	}
 	return false;
 }
 
 bool CCocoaEventEmitter::copyTextToClipboard(const ucstring &text)
 {
-#warning "OpenGL Driver: Missing Mac Implementation for copyTextToClipboard"
-	return false;
+	NSPasteboard *pasteboard = [NSPasteboard generalPasteboard];
+        [pasteboard clearContents];
+        NSArray *copiedObjects = [NSArray arrayWithObject:[NSString stringWithUTF8String:text.toUtf8().c_str()]];
+        [pasteboard writeObjects:copiedObjects];
+	return true;
 }
 
 /// convert modifier key state to nel internal modifier key state
